package com.unitesk.requality.api.models;

import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

import com.unitesk.requality.api.Utils;
import com.unitesk.requality.core.TreeNode;

public class IDList extends JsonOutputBase {
  private List<IDMapping> list;

  public IDList(List<IDMapping> list) {
    this.list = list;
  }

  public int getCount() {
    return list.size();
  }

  public List<IDMapping> getList() {
    return list;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((list == null) ? 0 : list.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    IDList other = (IDList) obj;
    if (list == null) {
      if (other.list != null) return false;
    } else if (!list.equals(other.list)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "IDList [list=" + list + "]";
  }

  public static IDList fromIterator(Iterator<TreeNode> nodes) {
    return new IDList(Utils.stream(nodes).map(IDMapping::fromNode).collect(Collectors.toList()));
  }
}
