package com.unitesk.requality.api.models;

import java.util.UUID;

import com.unitesk.requality.core.TreeNode;

public class IDMapping extends JsonOutputBase {
  private String qid;
  private UUID uuid;
  private String uv;

  public IDMapping(String qid, UUID uuid, String uv) {
    super();
    this.qid = qid;
    this.uuid = uuid;
    this.uv = uv;
  }

  public String getQid() {
    return qid;
  }

  public UUID getUuid() {
    return uuid;
  }

  public String getUv() {
    return uv;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((qid == null) ? 0 : qid.hashCode());
    result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
    result = prime * result + ((uv == null) ? 0 : uv.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    IDMapping other = (IDMapping) obj;
    if (qid == null) {
      if (other.qid != null) return false;
    } else if (!qid.equals(other.qid)) return false;
    if (uuid == null) {
      if (other.uuid != null) return false;
    } else if (!uuid.equals(other.uuid)) return false;
    if (uv == null) {
      if (other.uv != null) return false;
    } else if (!uv.equals(other.uv)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "IDMapping [qid=" + qid + ", uuid=" + uuid + ", uv=" + uv + "]";
  }

  public static IDMapping fromNode(TreeNode node) {
    return new IDMapping(node.getQualifiedId(), node.getUUId(), node.getUserVisibleName());
  }
}
