package com.unitesk.requality.api.services.nodes.output;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import com.unitesk.requality.api.models.JsonOutputBase;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;

public class AttributesResponse extends JsonOutputBase {
  private java.util.Map<String, AttributeResponse> ars;

  public AttributesResponse(java.util.Map<String, AttributeResponse> storage) {
    this.ars = storage;
  }
  public AttributesResponse(TreeNode node) {
    this(aMapFromNode(node));
  }
  public java.util.Map<String, AttributeResponse> getAttributes(){
    return ars;
  }
  private static Map<String, AttributeResponse> aMapFromNode(TreeNode node) {
    Map<String, AttributeResponse> val = new HashMap<>();
    for(Entry<String, Attribute> e:node.attrs().getActiveAttributes().entrySet())
      {
        Attribute a = e.getValue();
        if(!a.isVirtual())
          val.put(a.getKey(), AttributeResponse.getOne(node.attrs(), a,false));
      }
    return val;
  }
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((ars == null) ? 0 : ars.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    AttributesResponse other = (AttributesResponse) obj;
    if (ars == null) {
      if (other.ars != null) return false;
    } else if (!ars.equals(other.ars)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "AttributeResponse [attrs=" + ars + "]";
  }
}
