package com.unitesk.requality.api.services.nodes.output;

import java.util.UUID;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.unitesk.requality.core.attribute.AttributeStorage;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.attribute.ReferenceValue;

public class ReferenceResponse extends AttributeSingleResponse {
  private UUID[] nodes;

  @JsonInclude(JsonInclude.Include.NON_NULL)
  public UUID[] getNodes(){
    return nodes;
  }
  public ReferenceResponse(AttributeStorage storage, AttributeType at, Object value,boolean isSingle) {
    super(storage,at,value);
    if(isSingle){
      ReferenceValue rv = ((ReferenceValue)value);
      if(rv.hasErrorsOnResolve(storage))
        nodes = null;
      else{
        nodes = rv.getNodeUUIDs(storage);
      }
    }
  }
}
