package com.unitesk.requality.api.services.project.output;

import java.util.List;

import com.unitesk.requality.api.models.JsonOutputBase;

public class ProjectList extends JsonOutputBase {
  private List<String> projects;

  public ProjectList(List<String> projects) {
    super();
    this.projects = projects;
  }

  public int getCount() {
    return projects.size();
  }

  public List<String> getProjects() {
    return projects;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((projects == null) ? 0 : projects.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    ProjectList other = (ProjectList) obj;
    if (projects == null) {
      if (other.projects != null) return false;
    } else if (!projects.equals(other.projects)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "ProjectList [projects=" + projects + "]";
  }
}
