package com.unitesk.requality.api.services.project.output;

import java.util.LinkedList;
import java.util.List;
import com.unitesk.requality.api.models.JsonOutputBase;
import com.unitesk.requality.api.services.nodes.output.NodeResponse;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.InstancesFolder;
import com.unitesk.requality.nodetypes.NodeType;

public class ProjectResponse extends JsonOutputBase {
  private String name;
  private TreeNode root;

  public ProjectResponse(String name, TreeNode root) {
    this.name = name;
    this.root = root;
  }
//
//  public ProjectResponse(String name2, TreeNode rootNode) {
//    // TODO Auto-generated constructor stub
//  }

  public String getName() {
    return name;
  }

  public List<NodeResponse> getNodes() {
    List<NodeResponse> nr = new LinkedList<>();
    for(TreeNode node:root.getShownChildren()){
      String type = node.getType();
      if(type!=null && !type.equals(InstancesFolder.TYPE_NAME)&&
          !type.equals(NodeType.TYPE_NAME))
        nr.add(new NodeResponse(node,-1));
    }
    return nr;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    result = prime * result + ((root == null) ? 0 : root.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    ProjectResponse other = (ProjectResponse) obj;
    if (name == null) {
      if (other.name != null) return false;
    } else if (!name.equals(other.name)) return false;
    if (root == null) {
      if (other.root != null) return false;
    } else if (!root.equals(other.root)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "ProjectResponse [name="
        + name
        + ", root="
        + root
        + "]";
  }
}
