package com.unitesk.requality.api.services.report.output;

import java.net.URI;

import com.unitesk.requality.api.models.IDMapping;
import com.unitesk.requality.api.models.JsonOutputBase;

public class GeneratedReport extends JsonOutputBase {
  private IDMapping id;
  private URI href;

  public GeneratedReport(IDMapping id, URI href) {
    this.id = id;
    this.href = href;
  }

  public IDMapping getId() {
    return id;
  }

  public URI getHref() {
    return href;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((href == null) ? 0 : href.hashCode());
    result = prime * result + ((id == null) ? 0 : id.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    GeneratedReport other = (GeneratedReport) obj;
    if (href == null) {
      if (other.href != null) return false;
    } else if (!href.equals(other.href)) return false;
    if (id == null) {
      if (other.id != null) return false;
    } else if (!id.equals(other.id)) return false;
    return true;
  }

  @Override
  public String toString() {
    return "GeneratedReport [id=" + id + ", href=" + href + "]";
  }
}
